package com.fufan.mtsaas.modules.base.excel;

import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import lombok.extern.slf4j.Slf4j;

import java.util.ArrayList;

@Slf4j
public abstract class BaseExcelListener<T> extends AnalysisEventListener<T> {
    // 数据列表
    public ArrayList<T> list = new ArrayList<>();

//    private AttendanceMapper attendanceMapper;

    // 每隔10条数据批量存入一次数据
    public static final int BATCH_COUNT = 100;

    // 每次创建Listener的时候需要把spring管理的类传进来


    @Override
    public void invoke(T data, AnalysisContext analysisContext) {
        log.info("解析到一条记录:{}", data);
        // 将数据存入到数据列表
        list.add(data);
        // 达到BATCH_COUNT了，需要去存储一次数据库，防止数据几万条数据在内存，容易OOM
        if(list.size() >= BATCH_COUNT){
            // 调用mapper层的save方法
            savaData();
            // 存储完成清理 list
            list.clear();
        }
    }

    /**
     * 所有数据解析完成了 都会来调用
     *
     * @param context .
     */
    @Override
    public void doAfterAllAnalysed(AnalysisContext context) {
        // 当剩余的记录数不足BATCH_COUNT时，最终一次性存储数据
        savaData();
        log.info("所有数据解析完成");
    }

    protected abstract void savaData();


}
